//+------------------------------------------------------------------+
//|                                             TO_30pipsSystem2.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern int extPips = 10;
extern int extPipsOffset = 0;
extern double extSizeRatio = 0.01;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){return(0);}
int deinit(){return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

	double price = (Bid + Ask) / 2;
	double keyPrice = GetKeyPrice(price);
	if(IsNear(price, keyPrice))
	{
		//TakeProfit(keyPrice);	//changed to limit order.
		TakePosition(keyPrice);
	}
	//StopLoss(price);	//not implemented here. phoenix's stop loss funcion is good.
	return(0);
}

//+------------------------------------------------------------------+
double GetKeyPrice(double price)
{
	double d = MathRound(price / (extPips * Point));
	return(d * (extPips * Point) + (extPipsOffset * Point));
}

bool IsNear(double price, double keyPrice)
{
	double d = MathAbs(MathRound((price - keyPrice) / Point));
	return(d <= MarketInfo(Symbol(), MODE_SPREAD) / 2);	//what's better? any idea?
}

//+------------------------------------------------------------------+
//comment is like "1.2700_1.2730" means open price and tp price.
void TakePosition(double keyPrice)
{
	string comment_long = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice + extPips * Point), Digits);
	string comment_short = DoubleToStr(keyPrice, Digits) + "_" + DoubleToStr((keyPrice - extPips * Point), Digits);
	bool no_same_long = true;
	bool no_same_short = true;
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		if(OrderComment() == comment_long) no_same_long = false;
		if(OrderComment() == comment_short) no_same_short = false;		
	}
	Print(no_same_long + "  " + no_same_short);
	double lots = 0;
	double slippage = 2;	//MarketInfo(Symbol(), MODE_SPREAD); i dont know why 2 looks work good... anyone help.
	double tp = 0;
	if(no_same_long == true)
	{
		lots = GetLotSize();
		tp = keyPrice + (extPips * Point);
		if(OrderSend(Symbol(), OP_BUY, lots, keyPrice, slippage, 0, tp, comment_long, 0, 0, Blue) < 0)	//i dont know what price should be?
		{
			Print("Buy OrderSend failed with error #", GetLastError());
			return(0);
		}
	}
	if(no_same_short == true)
	{
		lots = GetLotSize();
		tp = keyPrice - (extPips * Point);
		if(OrderSend(Symbol(), OP_SELL, lots, keyPrice, slippage, 0, tp, comment_short, 0, 0, Red) < 0)	//i dont know what price should be?
		{
			Print("Sell OrderSend failed with error #", GetLastError());
			return(0);
		}
	}
}

double GetLotSize()
{
	double unit =  (AccountBalance() * extSizeRatio) / (extPips * Point);
	double lot = NormalizeDouble(unit * 0.00001, 2);	//2 means using 0.1Lot. phoenix's autolot() function is better.
	return(lot);
}

/*void TakeProfit(double keyPrice)
{
	for(int i = 0; i < OrdersTotal(); i++)
	{
		if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
		{
			Alert("OrderSelect retruned Error " + GetLastError());
			return(-1);
		}
		
		int pos = StringFind(OrderComment(), "_", 0);
		double tp  = StrToDouble(StringSubstr(OrderComment(), pos + 1));
		
		Print("keyPrice = " + keyPrice + " , tp = " + tp);
		if (keyPrice == tp)
		{
			if(OrderType() == OP_BUY)
				if(OrderClose(OrderTicket(), OrderLots(), Bid, 0, Green) == false) Print("OrderClose returns error #", GetLastError());
			if(OrderType() == OP_SELL)
				if(OrderClose(OrderTicket(), OrderLots(), Ask, 0, Pink) == false) Print("OrderClose returns error #", GetLastError());
		}
	}
}

void StopLoss(double price)
{
	
}
*/